--parse best m3u8 RESOLUTION
if #arg < 1 then return nil end

json = require "json"

local _url = arg[1]
local Curl = nil
local ret = {}

function getdata(Url)
	if Url == nil then return nil end
	if Curl == nil then
		Curl = curl.new()
	end
	local ret, data = Curl:download{ url=Url, A="Mozilla/5.0",connectTimeout=5,maxRedirs=5,followRedir=true}
	if ret == CURL.OK then
		return data
	else
		return nil
	end
end

function getVideoUrl(name)
	local urldata = "https://chaturbate.com/" .. name
	local data = getdata(urldata)
	if data == nil then return -1 end
	
	local m3u8_url = data:match("qualityPickerPlugin.-(http.-m3u8)") or data:match("src='(http.-m3u8)")
	if m3u8_url == nil then return -1 end

	local Age = data:match('<dt>Age.</dt><dd>(%d+)</dd>')
	local Real_Name =data:match('<dt>Real Name.</dt><dd>([%w%s%,%.%d]+)</dd>')
	local Location = data:match('<dt>Location:</dt><dd>([%w%s%,%.%d]+)</dd>')
	local Languages = data:match('<dt>Language.s.:</dt><dd>([ñ%w%s%,%.%d]+)</dd>')
-- 	local Sex = data:match('<dt>Sex:</dt><dd>([%w%s%,%.%d]+)</dd>')
	local Interested = data:match('<dt>Interested%s+In:</dt><dd>([%w%s%,%.%d]+)</dd>')


	if Real_Name == nil then Real_Name = "" end
	if Age then Real_Name = Real_Name .. "  " .. Age end
	if Location  then 	Real_Name = Real_Name .. " (" .. Location  .. ")"  end
	if Languages  then 	Real_Name = Real_Name .. "  Lan:" .. Languages end
	if Interested  then 	Real_Name = Real_Name .. "  Interested:" .. Interested  end
	if Sex  then 	Real_Name = Real_Name .. "  Sex:" .. Sex  .. ""  end

	if #Real_Name < 2 then Real_Name = nil end

	local res = 0
	local count = 0
	local data = getdata(m3u8_url)
	if data then
		local host = m3u8_url:match('([%a]+[:]?//[_%w%-%.]+)/')
		local lastpos = (m3u8_url:reverse()):find("/")
		local hosttmp = m3u8_url:sub(1,#m3u8_url-lastpos)
		if hosttmp then
			host = hosttmp .."/"
		end
		for band, res1, res2, url in data:gmatch('BANDWIDTH=(%d+).-RESOLUTION=(%d+)x(%d+).-\n(.-)\n') do
			if url and res1 then
				local nr = tonumber(res1)
				if nr < 2000 and nr > res then
					res=nr
					if host and url:sub(1,4) ~= "http" then
						url = host .. url
					end
					entry = {}
					entry['url']  = url
					entry['band'] = band
					entry['res1'] = res1
					entry['res2'] = res2
					entry['name'] = Real_Name or " RESOLUTION=" .. res1 .. "x" .. res2
					count = count + 1
					ret[count] = {}
					ret[count] = entry
				end
			end
		end
	else
		return -1 --url is offline
	end
	return res
end

local have_url = getVideoUrl(_url)
if have_url > 0 then
	return json:encode(ret)
end

return 0  --url is offline
